-- 
-- (c) Copyright 2008 - 2013 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES.
-- 
------------------------------------------------------------------------------
-- User entered comments
------------------------------------------------------------------------------
-- This is a self-desigined Memory model developed for EMC Testing purpose
--
------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.std_logic_misc.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


Library xpm;
use xpm.vcomponents.all;


library unisim;
use unisim.vcomponents.all;
library work;

entity axi_emc_0_exdes is
 PORT (
    clk50MHz    : in std_logic;
    reset       : in std_logic;
    dq           : inout std_logic_vector(15 DOWNTO 0);
    --dq_i         : in std_logic_vector(15 DOWNTO 0);
    --dq_o         : out std_logic_vector(15 DOWNTO 0);
    --dq_t         : out std_logic_vector(15 DOWNTO 0);
    a            : out std_logic_vector(31 DOWNTO 0);
    cen          : out std_logic_vector(0 DOWNTO 0);
    oen          : out std_logic_vector(0 DOWNTO 0);
    wen          : out std_logic;
    ben          : out std_logic_vector(1 DOWNTO 0);
    cken         : out std_logic;
    clk          : out std_logic;
    mwait        : in std_logic_vector(0 DOWNTO 0);
    atg_done     : out std_logic;
    atg_status  : out std_logic_vector(1 DOWNTO 0)
 );
end entity;

architecture impl of axi_emc_0_exdes is

--------------------------------------------------------------------------------------
-- below attributes are added to reduce the synth warnings in Vivado tool
  attribute DowngradeIPIdentifiedWarnings: string;
  attribute DowngradeIPIdentifiedWarnings of impl : architecture is "yes";
--------------------------------------------------------------------------------------

COMPONENT clk_wiz_0
port
 (
  clk_in1           : in     std_logic;
  clk_out1          : out    std_logic;
  reset             : in     std_logic;
  locked            : out    std_logic
 );
end COMPONENT;

COMPONENT axi_traffic_gen_0
  PORT (
    s_axi_aclk : in std_logic;
    s_axi_aresetn : in std_logic;
    m_axi_lite_ch1_awaddr : out std_logic_vector(31 DOWNTO 0);
    m_axi_lite_ch1_awprot : out std_logic_vector(2 DOWNTO 0);
    m_axi_lite_ch1_awvalid : out std_logic;
    m_axi_lite_ch1_awready : in std_logic;
    m_axi_lite_ch1_wdata : out std_logic_vector(31 DOWNTO 0);
    m_axi_lite_ch1_wstrb : out std_logic_vector(3 DOWNTO 0);
    m_axi_lite_ch1_wvalid : out std_logic;
    m_axi_lite_ch1_wready : in std_logic;
    m_axi_lite_ch1_bresp : in std_logic_vector(1 DOWNTO 0);
    m_axi_lite_ch1_bvalid : in std_logic;
    m_axi_lite_ch1_bready : out std_logic;
    m_axi_lite_ch1_araddr : out std_logic_vector(31 DOWNTO 0);
    m_axi_lite_ch1_arvalid : out std_logic;
    m_axi_lite_ch1_arready : in std_logic;
    m_axi_lite_ch1_rdata : in std_logic_vector(31 DOWNTO 0);
    m_axi_lite_ch1_rvalid : in std_logic;
    m_axi_lite_ch1_rready : out std_logic;
    m_axi_lite_ch1_rresp : in std_logic_vector(1 DOWNTO 0);
    m_axi_lite_ch2_awaddr : out std_logic_vector(31 DOWNTO 0);
    m_axi_lite_ch2_awprot : out std_logic_vector(2 DOWNTO 0);
    m_axi_lite_ch2_awvalid : out std_logic;
    m_axi_lite_ch2_awready : in std_logic;
    m_axi_lite_ch2_wdata : out std_logic_vector(31 DOWNTO 0);
    m_axi_lite_ch2_wstrb : out std_logic_vector(3 DOWNTO 0);
    m_axi_lite_ch2_wvalid : out std_logic;
    m_axi_lite_ch2_wready : in std_logic;
    m_axi_lite_ch2_bresp : in std_logic_vector(1 DOWNTO 0);
    m_axi_lite_ch2_bvalid : in std_logic;
    m_axi_lite_ch2_bready : out std_logic;
    m_axi_lite_ch2_araddr : out std_logic_vector(31 DOWNTO 0);
    m_axi_lite_ch2_arvalid : out std_logic;
    m_axi_lite_ch2_arready : in std_logic;
    m_axi_lite_ch2_rdata : in std_logic_vector(31 DOWNTO 0);
    m_axi_lite_ch2_rvalid : in std_logic;
    m_axi_lite_ch2_rready : out std_logic;
    m_axi_lite_ch2_rresp : in std_logic_vector(1 DOWNTO 0);
    done : out std_logic;
    status : out std_logic_vector(31 DOWNTO 0)
  );
END COMPONENT;

COMPONENT axi_cdma_1
  PORT (
    m_axi_aclk : in std_logic;
    s_axi_lite_aclk : in std_logic;
    s_axi_lite_aresetn : in std_logic;
    cdma_introut : out std_logic;
    s_axi_lite_awready : out std_logic;
    s_axi_lite_awvalid : in std_logic;
    s_axi_lite_awaddr : in std_logic_vector(5 DOWNTO 0);
    s_axi_lite_wready : out std_logic;
    s_axi_lite_wvalid : in std_logic;
    s_axi_lite_wdata : in std_logic_vector(31 DOWNTO 0);
    s_axi_lite_bready : in std_logic;
    s_axi_lite_bvalid : out std_logic;
    s_axi_lite_bresp : out std_logic_vector(1 DOWNTO 0);
    s_axi_lite_arready : out std_logic;
    s_axi_lite_arvalid : in std_logic;
    s_axi_lite_araddr : in std_logic_vector(5 DOWNTO 0);
    s_axi_lite_rready : in std_logic;
    s_axi_lite_rvalid : out std_logic;
    s_axi_lite_rdata : out std_logic_vector(31 DOWNTO 0);
    s_axi_lite_rresp : out std_logic_vector(1 DOWNTO 0);
    m_axi_arready : in std_logic;
    m_axi_arvalid : out std_logic;
    m_axi_araddr : out std_logic_vector(31 DOWNTO 0);
    m_axi_arlen : out std_logic_vector(7 DOWNTO 0);
    m_axi_arsize : out std_logic_vector(2 DOWNTO 0);
    m_axi_arburst : out std_logic_vector(1 DOWNTO 0);
    m_axi_arprot : out std_logic_vector(2 DOWNTO 0);
    m_axi_arcache : out std_logic_vector(3 DOWNTO 0);
    m_axi_rready : out std_logic;
    m_axi_rvalid : in std_logic;
    m_axi_rdata : in std_logic_vector(31 DOWNTO 0);
    m_axi_rresp : in std_logic_vector(1 DOWNTO 0);
    m_axi_rlast : in std_logic;
    m_axi_awready : in std_logic;
    m_axi_awvalid : out std_logic;
    m_axi_awaddr : out std_logic_vector(31 DOWNTO 0);
    m_axi_awlen : out std_logic_vector(7 DOWNTO 0);
    m_axi_awsize : out std_logic_vector(2 DOWNTO 0);
    m_axi_awburst : out std_logic_vector(1 DOWNTO 0);
    m_axi_awprot : out std_logic_vector(2 DOWNTO 0);
    m_axi_awcache : out std_logic_vector(3 DOWNTO 0);
    m_axi_wready : in std_logic;
    m_axi_wvalid : out std_logic;
    m_axi_wdata : out std_logic_vector(31 DOWNTO 0);
    m_axi_wstrb : out std_logic_vector(3 DOWNTO 0);
    m_axi_wlast : out std_logic;
    m_axi_bready : out std_logic;
    m_axi_bvalid : in std_logic;
    m_axi_bresp : in std_logic_vector(1 DOWNTO 0);
    cdma_tvect_out : out std_logic_vector(31 DOWNTO 0)
  );
END COMPONENT;


COMPONENT axi_cdma_0
  PORT (
    m_axi_aclk : in std_logic;
    s_axi_lite_aclk : in std_logic;
    s_axi_lite_aresetn : in std_logic;
    cdma_introut : out std_logic;
    s_axi_lite_awready : out std_logic;
    s_axi_lite_awvalid : in std_logic;
    s_axi_lite_awaddr : in std_logic_vector(5 DOWNTO 0);
    s_axi_lite_wready : out std_logic;
    s_axi_lite_wvalid : in std_logic;
    s_axi_lite_wdata : in std_logic_vector(31 DOWNTO 0);
    s_axi_lite_bready : in std_logic;
    s_axi_lite_bvalid : out std_logic;
    s_axi_lite_bresp : out std_logic_vector(1 DOWNTO 0);
    s_axi_lite_arready : out std_logic;
    s_axi_lite_arvalid : in std_logic;
    s_axi_lite_araddr : in std_logic_vector(5 DOWNTO 0);
    s_axi_lite_rready : in std_logic;
    s_axi_lite_rvalid : out std_logic;
    s_axi_lite_rdata : out std_logic_vector(31 DOWNTO 0);
    s_axi_lite_rresp : out std_logic_vector(1 DOWNTO 0);
    m_axi_arready : in std_logic;
    m_axi_arvalid : out std_logic;
    m_axi_araddr : out std_logic_vector(31 DOWNTO 0);
    m_axi_arlen : out std_logic_vector(7 DOWNTO 0);
    m_axi_arsize : out std_logic_vector(2 DOWNTO 0);
    m_axi_arburst : out std_logic_vector(1 DOWNTO 0);
    m_axi_arprot : out std_logic_vector(2 DOWNTO 0);
    m_axi_arcache : out std_logic_vector(3 DOWNTO 0);
    m_axi_rready : out std_logic;
    m_axi_rvalid : in std_logic;
    m_axi_rdata : in std_logic_vector(31 DOWNTO 0);
    m_axi_rresp : in std_logic_vector(1 DOWNTO 0);
    m_axi_rlast : in std_logic;
    m_axi_awready : in std_logic;
    m_axi_awvalid : out std_logic;
    m_axi_awaddr : out std_logic_vector(31 DOWNTO 0);
    m_axi_awlen : out std_logic_vector(7 DOWNTO 0);
    m_axi_awsize : out std_logic_vector(2 DOWNTO 0);
    m_axi_awburst : out std_logic_vector(1 DOWNTO 0);
    m_axi_awprot : out std_logic_vector(2 DOWNTO 0);
    m_axi_awcache : out std_logic_vector(3 DOWNTO 0);
    m_axi_wready : in std_logic;
    m_axi_wvalid : out std_logic;
    m_axi_wdata : out std_logic_vector(31 DOWNTO 0);
    m_axi_wstrb : out std_logic_vector(3 DOWNTO 0);
    m_axi_wlast : out std_logic;
    m_axi_bready : out std_logic;
    m_axi_bvalid : in std_logic;
    m_axi_bresp : in std_logic_vector(1 DOWNTO 0);
    cdma_tvect_out : out std_logic_vector(31 DOWNTO 0)
  );
END COMPONENT;

--COMPONENT blk_mem_gen_0
--  PORT (
--    s_aclk : in std_logic;
--    s_aresetn : in std_logic;
--    s_axi_awid : in std_logic_vector(0 DOWNTO 0);
--    s_axi_awaddr : in std_logic_vector(31 DOWNTO 0);
--    s_axi_awlen : in std_logic_vector(7 DOWNTO 0);
--    s_axi_awsize : in std_logic_vector(2 DOWNTO 0);
--    s_axi_awburst : in std_logic_vector(1 DOWNTO 0);
--    s_axi_awvalid : in std_logic;
--    s_axi_awready : out std_logic;
--    s_axi_wdata : in std_logic_vector(31 DOWNTO 0);
--    s_axi_wstrb : in std_logic_vector(3 DOWNTO 0);
--    s_axi_wlast : in std_logic;
--    s_axi_wvalid : in std_logic;
--    s_axi_wready : out std_logic;
--    s_axi_bid : out std_logic_vector(0 DOWNTO 0);
--    s_axi_bresp : out std_logic_vector(1 DOWNTO 0);
--    s_axi_bvalid : out std_logic;
--    s_axi_bready : in std_logic;
--    s_axi_arid : in std_logic_vector(0 DOWNTO 0);
--    s_axi_araddr : in std_logic_vector(31 DOWNTO 0);
--    s_axi_arlen : in std_logic_vector(7 DOWNTO 0);
--    s_axi_arsize : in std_logic_vector(2 DOWNTO 0);
--    s_axi_arburst : in std_logic_vector(1 DOWNTO 0);
--    s_axi_arvalid : in std_logic;
--    s_axi_arready : out std_logic;
--    s_axi_rid : out std_logic_vector(0 DOWNTO 0);
--    s_axi_rdata : out std_logic_vector(31 DOWNTO 0);
--    s_axi_rresp : out std_logic_vector(1 DOWNTO 0);
--    s_axi_rlast : out std_logic;
--    s_axi_rvalid : out std_logic;
--    s_axi_rready : in std_logic
--  );
--  END COMPONENT;



COMPONENT axi_bram_ctrl_3
  PORT (
    s_axi_aclk : IN STD_LOGIC;
    s_axi_aresetn : IN STD_LOGIC;
    s_axi_awaddr : IN STD_LOGIC_VECTOR(11 DOWNTO 0);
    s_axi_araddr : IN STD_LOGIC_VECTOR(11 DOWNTO 0);
    bram_we_a : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
    bram_addr_a : OUT STD_LOGIC_VECTOR(11 DOWNTO 0);
    bram_wrdata_a : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    bram_rddata_a : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
    s_axi_awlen : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    s_axi_awsize : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
    s_axi_awburst : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
    s_axi_awlock : IN STD_LOGIC;
    s_axi_awcache : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
    s_axi_awprot : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
    s_axi_awvalid : IN STD_LOGIC;
    s_axi_awready : OUT STD_LOGIC;
    s_axi_wdata : IN STD_LOGIC_VECTOR(31 DOWNTO 0);  ---(31 DOWNTO 0);
    s_axi_wstrb : IN STD_LOGIC_VECTOR(3 DOWNTO 0);--(3 DOWNTO 0);
    s_axi_wlast : IN STD_LOGIC;
    s_axi_wvalid : IN STD_LOGIC;
    s_axi_wready : OUT STD_LOGIC;
    s_axi_bresp : OUT STD_LOGIC_VECTOR(1 DOWNTO 0);
    s_axi_bvalid : OUT STD_LOGIC;
    s_axi_bready : IN STD_LOGIC;
    s_axi_arlen : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    s_axi_arsize : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
    s_axi_arburst : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
    s_axi_arlock : IN STD_LOGIC;
    s_axi_arcache : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
    s_axi_arprot : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
    s_axi_arvalid : IN STD_LOGIC;
    s_axi_arready : OUT STD_LOGIC;
    s_axi_rdata : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);  ---(31 DOWNTO 0);
    s_axi_rresp : OUT STD_LOGIC_VECTOR(1 DOWNTO 0);
    s_axi_rlast : OUT STD_LOGIC;
    s_axi_rvalid : OUT STD_LOGIC;
    s_axi_rready : IN STD_LOGIC;
    bram_rst_a : OUT STD_LOGIC;
    bram_clk_a : OUT STD_LOGIC;
    bram_en_a : OUT STD_LOGIC
     );
END COMPONENT;



COMPONENT axi_emc_0
  PORT (
    s_axi_aclk : in std_logic;
    s_axi_aresetn : in std_logic;
    rdclk : in std_logic;
    s_axi_mem_awaddr : in std_logic_vector(31 DOWNTO 0);
    s_axi_mem_awlen : in std_logic_vector(7 DOWNTO 0);
    s_axi_mem_awsize : in std_logic_vector(2 DOWNTO 0);
    s_axi_mem_awburst : in std_logic_vector(1 DOWNTO 0);
    s_axi_mem_awlock : in std_logic;
    s_axi_mem_awcache : in std_logic_vector(3 DOWNTO 0);
    s_axi_mem_awprot : in std_logic_vector(2 DOWNTO 0);
    s_axi_mem_awvalid : in std_logic;
    s_axi_mem_awready : out std_logic;
    s_axi_mem_wdata : in std_logic_vector(31 DOWNTO 0);
    s_axi_mem_wstrb : in std_logic_vector(3 DOWNTO 0);
    s_axi_mem_wlast : in std_logic;
    s_axi_mem_wvalid : in std_logic;
    s_axi_mem_wready : out std_logic;
    s_axi_mem_bresp : out std_logic_vector(1 DOWNTO 0);
    s_axi_mem_bvalid : out std_logic;
    s_axi_mem_bready : in std_logic;
    s_axi_mem_araddr : in std_logic_vector(31 DOWNTO 0);
    s_axi_mem_arlen : in std_logic_vector(7 DOWNTO 0);
    s_axi_mem_arsize : in std_logic_vector(2 DOWNTO 0);
    s_axi_mem_arburst : in std_logic_vector(1 DOWNTO 0);
    s_axi_mem_arlock : in std_logic;
    s_axi_mem_arcache : in std_logic_vector(3 DOWNTO 0);
    s_axi_mem_arprot : in std_logic_vector(2 DOWNTO 0);
    s_axi_mem_arvalid : in std_logic;
    s_axi_mem_arready : out std_logic;
    s_axi_mem_rdata : out std_logic_vector(31 DOWNTO 0);
    s_axi_mem_rresp : out std_logic_vector(1 DOWNTO 0);
    s_axi_mem_rlast : out std_logic;
    s_axi_mem_rvalid : out std_logic;
    s_axi_mem_rready : in std_logic;
    mem_dq_i : in std_logic_vector(15 DOWNTO 0);
    mem_dq_o : out std_logic_vector(15 DOWNTO 0);
    mem_dq_t : out std_logic_vector(15 DOWNTO 0);
    mem_a : out std_logic_vector(31 DOWNTO 0);
    mem_ce : out std_logic_vector(0 DOWNTO 0);
    mem_cen : out std_logic_vector(0 DOWNTO 0);
    mem_oen : out std_logic_vector(0 DOWNTO 0);
    mem_wen : out std_logic;
    mem_ben : out std_logic_vector(1 DOWNTO 0);
    mem_qwen : out std_logic_vector(1 DOWNTO 0);
    mem_rpn : out std_logic;
    mem_adv_ldn : out std_logic;
    mem_lbon : out std_logic;
    mem_cken : out std_logic;
    mem_rnw : out std_logic;
    mem_cre : out std_logic;
    mem_wait : in std_logic_vector(0 DOWNTO 0)
  );
END COMPONENT;



signal  emc_axi_awaddr :  std_logic_vector(31 DOWNTO 0);
signal  emc_axi_awlen :  std_logic_vector(7 DOWNTO 0);
signal  emc_axi_awsize :  std_logic_vector(2 DOWNTO 0);
signal  emc_axi_awburst :  std_logic_vector(1 DOWNTO 0);
signal  emc_axi_awcache :  std_logic_vector(3 DOWNTO 0);
signal  emc_axi_awprot :  std_logic_vector(2 DOWNTO 0);
signal  emc_axi_awvalid :  std_logic;
signal  emc_axi_awready :  std_logic;
signal  emc_axi_wdata :  std_logic_vector(31 DOWNTO 0);
signal  emc_axi_wstrb :  std_logic_vector(3 DOWNTO 0);
signal  emc_axi_wlast :  std_logic;
signal  emc_axi_wvalid :  std_logic;
signal  emc_axi_wready :  std_logic;
signal  emc_axi_bresp :  std_logic_vector(1 DOWNTO 0);
signal  emc_axi_bvalid :  std_logic;
signal  emc_axi_bready :  std_logic;
signal  emc_axi_araddr :  std_logic_vector(31 DOWNTO 0);
signal  emc_axi_arlen :  std_logic_vector(7 DOWNTO 0);
signal  emc_axi_arsize :  std_logic_vector(2 DOWNTO 0);
signal  emc_axi_arburst :  std_logic_vector(1 DOWNTO 0);
signal  emc_axi_arcache :  std_logic_vector(3 DOWNTO 0);
signal  emc_axi_arprot :  std_logic_vector(2 DOWNTO 0);
signal  emc_axi_arvalid :  std_logic;
signal  emc_axi_arready :  std_logic;
signal  emc_axi_rdata :  std_logic_vector(31 DOWNTO 0);
signal  emc_axi_rresp :  std_logic_vector(1 DOWNTO 0);
signal  emc_axi_rlast :  std_logic;
signal  emc_axi_rvalid :  std_logic;
signal  emc_axi_rready :  std_logic;

signal  bmg_axi_awaddr :  std_logic_vector(31 DOWNTO 0);
signal  bmg_axi_awlen :  std_logic_vector(7 DOWNTO 0);
signal  bmg_axi_awsize :  std_logic_vector(2 DOWNTO 0);
signal  bmg_axi_awburst :  std_logic_vector(1 DOWNTO 0);
signal  bmg_axi_awvalid :  std_logic;
signal  bmg_axi_awready :  std_logic;
signal  bmg_axi_wdata :  std_logic_vector(31 DOWNTO 0);
signal  bmg_axi_wstrb :  std_logic_vector(3 DOWNTO 0);
signal  bmg_axi_wlast :  std_logic;
signal  bmg_axi_wvalid :  std_logic;
signal  bmg_axi_wready :  std_logic;
signal  bmg_axi_bid :  std_logic_vector(0 DOWNTO 0);
signal  bmg_axi_bresp :  std_logic_vector(1 DOWNTO 0);
signal  bmg_axi_bvalid :  std_logic;
signal  bmg_axi_bready :  std_logic;
signal  bmg_axi_araddr :  std_logic_vector(31 DOWNTO 0);
signal  bmg_axi_arlen :  std_logic_vector(7 DOWNTO 0);
signal  bmg_axi_arsize :  std_logic_vector(2 DOWNTO 0);
signal  bmg_axi_arburst :  std_logic_vector(1 DOWNTO 0);
signal  bmg_axi_arvalid :  std_logic;
signal  bmg_axi_arready :  std_logic;
signal  bmg_axi_rid :  std_logic_vector(0 DOWNTO 0);
signal  bmg_axi_rdata :  std_logic_vector(31 DOWNTO 0);
signal  bmg_axi_rresp :  std_logic_vector(1 DOWNTO 0);
signal  bmg_axi_rlast :  std_logic;
signal  bmg_axi_rvalid :  std_logic;
signal  bmg_axi_rready :  std_logic;

signal  r_atg_lite_awready :  std_logic;
signal  r_atg_lite_awvalid :  std_logic;
signal  r_atg_lite_awaddr :  std_logic_vector(31 DOWNTO 0);
signal  r_atg_lite_wready :  std_logic;
signal  r_atg_lite_wvalid :  std_logic;
signal  r_atg_lite_wdata :  std_logic_vector(31 DOWNTO 0);
signal  r_atg_lite_bready :  std_logic;
signal  r_atg_lite_bvalid :  std_logic;
signal  r_atg_lite_bresp :  std_logic_vector(1 DOWNTO 0);
signal  r_atg_lite_arready :  std_logic;
signal  r_atg_lite_arvalid :  std_logic;
signal  r_atg_lite_araddr :  std_logic_vector(31 DOWNTO 0);
signal  r_atg_lite_rready :  std_logic;
signal  r_atg_lite_rvalid :  std_logic;
signal  r_atg_lite_rdata :  std_logic_vector(31 DOWNTO 0);
signal  r_atg_lite_rresp :  std_logic_vector(1 DOWNTO 0);

signal  w_atg_lite_awready :  std_logic;
signal  w_atg_lite_awvalid :  std_logic;
signal  w_atg_lite_awaddr :  std_logic_vector(31 DOWNTO 0);
signal  w_atg_lite_wready :  std_logic;
signal  w_atg_lite_wvalid :  std_logic;
signal  w_atg_lite_wdata :  std_logic_vector(31 DOWNTO 0);
signal  w_atg_lite_bready :  std_logic;
signal  w_atg_lite_bvalid :  std_logic;
signal  w_atg_lite_bresp :  std_logic_vector(1 DOWNTO 0);
signal  w_atg_lite_arready :  std_logic;
signal  w_atg_lite_arvalid :  std_logic;
signal  w_atg_lite_araddr :  std_logic_vector(31 DOWNTO 0);
signal  w_atg_lite_rready :  std_logic;
signal  w_atg_lite_rvalid :  std_logic;
signal  w_atg_lite_rdata :  std_logic_vector(31 DOWNTO 0);
signal  w_atg_lite_rresp :  std_logic_vector(1 DOWNTO 0);

signal  atg_stat    :  std_logic_vector(31 DOWNTO 0);
signal  dq_i        :  std_logic_vector(15 DOWNTO 0);
signal  dq_o        :  std_logic_vector(15 DOWNTO 0);
signal  dq_t        :  std_logic_vector(15 DOWNTO 0);
signal  axi_clk      :  std_logic;
signal  locked       :  std_logic;
signal  axi_aresetn  :  std_logic;

---------abc+xpm signals--------------------------
signal BRAM_Clk_A    : std_logic;
signal BRAM_Rst_A    : std_logic;
signal BRAM_En_A     : std_logic;
signal BRAM_WE_A     : std_logic_vector(3 DOWNTO 0) := (others => '0');
signal BRAM_Addr_A   : std_logic_vector(11 DOWNTO 0) := (others => '0');
signal BRAM_WrData_A : std_logic_vector(31 DOWNTO 0) := (others => '0');
signal BRAM_RdData_A : std_logic_vector(31 DOWNTO 0) := (others => '0');

--------------------------------------------------

begin
----Internal Signal Assignments
 axi_aresetn <= locked;
 clk <= axi_clk;
 atg_status <= atg_stat(1 DOWNTO 0);

data :for j in 0 to 15 generate
  prh_j : IOBUF
        port map (
          IO => dq(j),
          I => dq_o(j),
          O => dq_i(j),
          T => dq_t(j));
end generate data ;

--data :for j in 0 to 15 generate
--  prh_j : IOBUF
--        port map (
--          IO => dq(j),
--          I => dq_i(j),
--          O => dq_o(j),
--          T => dq_t(j));
--end generate data ;

CLK_GEN : clk_wiz_0
   port map ( 
   clk_in1 => clk50MHz,
   clk_out1 => axi_clk,
   reset => reset,
   locked => locked            
 );


READ_CDMA : axi_cdma_1
 port map (
    m_axi_aclk =>                axi_clk,
    s_axi_lite_aclk =>           axi_clk,
    s_axi_lite_aresetn =>        axi_aresetn,
    cdma_introut =>              open,
    s_axi_lite_awready =>        r_atg_lite_awready,
    s_axi_lite_awvalid =>        r_atg_lite_awvalid,
    s_axi_lite_awaddr =>         r_atg_lite_awaddr(5 downto 0), 
    s_axi_lite_wready =>         r_atg_lite_wready, 
    s_axi_lite_wvalid =>         r_atg_lite_wvalid, 
    s_axi_lite_wdata =>          r_atg_lite_wdata,
    s_axi_lite_bready =>         r_atg_lite_bready, 
    s_axi_lite_bvalid =>         r_atg_lite_bvalid, 
    s_axi_lite_bresp =>          r_atg_lite_bresp,
    s_axi_lite_arready =>        r_atg_lite_arready,
    s_axi_lite_arvalid =>        r_atg_lite_arvalid,
    s_axi_lite_araddr =>         r_atg_lite_araddr(5 downto 0), 
    s_axi_lite_rready =>         r_atg_lite_rready, 
    s_axi_lite_rvalid =>         r_atg_lite_rvalid, 
    s_axi_lite_rdata =>          r_atg_lite_rdata,
    s_axi_lite_rresp =>          r_atg_lite_rresp,
    m_axi_arready =>             emc_axi_arready,
    m_axi_arvalid =>             emc_axi_arvalid,
    m_axi_araddr =>              emc_axi_araddr,
    m_axi_arlen =>               emc_axi_arlen,
    m_axi_arsize =>              emc_axi_arsize,
    m_axi_arburst =>             emc_axi_arburst,
    m_axi_arprot =>              emc_axi_arprot,
    m_axi_arcache =>             emc_axi_arcache,
    m_axi_rready =>              emc_axi_rready,
    m_axi_rvalid =>              emc_axi_rvalid,
    m_axi_rdata =>               emc_axi_rdata,
    m_axi_rresp =>               emc_axi_rresp,
    m_axi_rlast =>               emc_axi_rlast,
    m_axi_awready =>             bmg_axi_awready,
    m_axi_awvalid =>             bmg_axi_awvalid,
    m_axi_awaddr =>              bmg_axi_awaddr,
    m_axi_awlen =>               bmg_axi_awlen,
    m_axi_awsize =>              bmg_axi_awsize,
    m_axi_awburst =>             bmg_axi_awburst,
    m_axi_awprot =>              open,
    m_axi_awcache =>             open,
    m_axi_wready =>              bmg_axi_wready,
    m_axi_wvalid =>              bmg_axi_wvalid,
    m_axi_wdata =>               bmg_axi_wdata,
    m_axi_wstrb =>               bmg_axi_wstrb,
    m_axi_wlast =>               bmg_axi_wlast,
    m_axi_bready =>              bmg_axi_bready,
    m_axi_bvalid =>              bmg_axi_bvalid,
    m_axi_bresp =>               bmg_axi_bresp,
    cdma_tvect_out =>            open
);

WRITE_CDMA : axi_cdma_0
 port map (
    m_axi_aclk =>                axi_clk,
    s_axi_lite_aclk =>           axi_clk,
    s_axi_lite_aresetn =>        axi_aresetn,
    cdma_introut =>              open,
    s_axi_lite_awready =>        w_atg_lite_awready,
    s_axi_lite_awvalid =>        w_atg_lite_awvalid,
    s_axi_lite_awaddr =>         w_atg_lite_awaddr(5 downto 0), 
    s_axi_lite_wready =>         w_atg_lite_wready, 
    s_axi_lite_wvalid =>         w_atg_lite_wvalid, 
    s_axi_lite_wdata =>          w_atg_lite_wdata,
    s_axi_lite_bready =>         w_atg_lite_bready, 
    s_axi_lite_bvalid =>         w_atg_lite_bvalid, 
    s_axi_lite_bresp =>          w_atg_lite_bresp,
    s_axi_lite_arready =>        w_atg_lite_arready,
    s_axi_lite_arvalid =>        w_atg_lite_arvalid,
    s_axi_lite_araddr =>         w_atg_lite_araddr(5 downto 0), 
    s_axi_lite_rready =>         w_atg_lite_rready, 
    s_axi_lite_rvalid =>         w_atg_lite_rvalid, 
    s_axi_lite_rdata =>          w_atg_lite_rdata,
    s_axi_lite_rresp =>          w_atg_lite_rresp,
    m_axi_arready =>             bmg_axi_arready,
    m_axi_arvalid =>             bmg_axi_arvalid,
    m_axi_araddr =>              bmg_axi_araddr,
    m_axi_arlen =>               bmg_axi_arlen,
    m_axi_arsize =>              bmg_axi_arsize,
    m_axi_arburst =>             bmg_axi_arburst,
    m_axi_arprot =>              open,
    m_axi_arcache =>             open,
    m_axi_rready =>              bmg_axi_rready,
    m_axi_rvalid =>              bmg_axi_rvalid,
    m_axi_rdata =>               bmg_axi_rdata,
    m_axi_rresp =>               bmg_axi_rresp,
    m_axi_rlast =>               bmg_axi_rlast,
    m_axi_awready =>             emc_axi_awready,
    m_axi_awvalid =>             emc_axi_awvalid,
    m_axi_awaddr =>              emc_axi_awaddr,
    m_axi_awlen =>               emc_axi_awlen,
    m_axi_awsize =>              emc_axi_awsize,
    m_axi_awburst =>             emc_axi_awburst,
    m_axi_awprot =>              emc_axi_awprot,
    m_axi_awcache =>             emc_axi_awcache,
    m_axi_wready =>              emc_axi_wready,
    m_axi_wvalid =>              emc_axi_wvalid,
    m_axi_wdata =>               emc_axi_wdata,
    m_axi_wstrb =>               emc_axi_wstrb,
    m_axi_wlast =>               emc_axi_wlast,
    m_axi_bready =>              emc_axi_bready,
    m_axi_bvalid =>              emc_axi_bvalid,
    m_axi_bresp =>               emc_axi_bresp,
    cdma_tvect_out =>            open
);

ATG : axi_traffic_gen_0
  port map (
    s_axi_aclk =>                      axi_clk,
    s_axi_aresetn =>                   axi_aresetn,
    m_axi_lite_ch1_awaddr =>           r_atg_lite_awaddr,
    m_axi_lite_ch1_awprot =>           open,
    m_axi_lite_ch1_awvalid =>          r_atg_lite_awvalid,
    m_axi_lite_ch1_awready =>          r_atg_lite_awready,
    m_axi_lite_ch1_wdata =>            r_atg_lite_wdata,
    m_axi_lite_ch1_wstrb =>            open,
    m_axi_lite_ch1_wvalid =>           r_atg_lite_wvalid,
    m_axi_lite_ch1_wready =>           r_atg_lite_wready,
    m_axi_lite_ch1_bresp =>            r_atg_lite_bresp,
    m_axi_lite_ch1_bvalid =>           r_atg_lite_bvalid,
    m_axi_lite_ch1_bready =>           r_atg_lite_bready,
    m_axi_lite_ch1_araddr =>           r_atg_lite_araddr,
    m_axi_lite_ch1_arvalid =>          r_atg_lite_arvalid,
    m_axi_lite_ch1_arready =>          r_atg_lite_arready,
    m_axi_lite_ch1_rdata =>            r_atg_lite_rdata,
    m_axi_lite_ch1_rvalid =>           r_atg_lite_rvalid,
    m_axi_lite_ch1_rready =>           r_atg_lite_rready,
    m_axi_lite_ch1_rresp =>            r_atg_lite_rresp,
    m_axi_lite_ch2_awaddr =>           w_atg_lite_awaddr,
    m_axi_lite_ch2_awprot =>           open,
    m_axi_lite_ch2_awvalid =>          w_atg_lite_awvalid,
    m_axi_lite_ch2_awready =>          w_atg_lite_awready,
    m_axi_lite_ch2_wdata =>            w_atg_lite_wdata,
    m_axi_lite_ch2_wstrb =>            open,
    m_axi_lite_ch2_wvalid =>           w_atg_lite_wvalid,
    m_axi_lite_ch2_wready =>           w_atg_lite_wready,
    m_axi_lite_ch2_bresp =>            w_atg_lite_bresp,
    m_axi_lite_ch2_bvalid =>           w_atg_lite_bvalid,
    m_axi_lite_ch2_bready =>           w_atg_lite_bready,
    m_axi_lite_ch2_araddr =>           w_atg_lite_araddr,
    m_axi_lite_ch2_arvalid =>          w_atg_lite_arvalid,
    m_axi_lite_ch2_arready =>          w_atg_lite_arready,
    m_axi_lite_ch2_rdata =>            w_atg_lite_rdata,
    m_axi_lite_ch2_rvalid =>           w_atg_lite_rvalid,
    m_axi_lite_ch2_rready =>           w_atg_lite_rready,
    m_axi_lite_ch2_rresp =>            w_atg_lite_rresp,
    done =>                            atg_done,
    status =>                          atg_stat
  );


--BMG : blk_mem_gen_0
--  port map (
--    s_aclk =>             axi_clk,
--    s_aresetn =>          axi_aresetn,
--    s_axi_awid =>         (others => '0'),
--    s_axi_awaddr =>       bmg_axi_awaddr, 
--    s_axi_awlen =>        bmg_axi_awlen,
--    s_axi_awsize =>       bmg_axi_awsize, 
--    s_axi_awburst =>      bmg_axi_awburst,
--    s_axi_awvalid =>      bmg_axi_awvalid,
--    s_axi_awready =>      bmg_axi_awready,
--    s_axi_wdata =>        bmg_axi_wdata,
--    s_axi_wstrb =>        bmg_axi_wstrb,
--    s_axi_wlast =>        bmg_axi_wlast,
--    s_axi_wvalid =>       bmg_axi_wvalid, 
--    s_axi_wready =>       bmg_axi_wready,
--    s_axi_bid =>          bmg_axi_bid, 
--    s_axi_bresp =>        bmg_axi_bresp,
--    s_axi_bvalid =>       bmg_axi_bvalid, 
--    s_axi_bready =>       bmg_axi_bready, 
--    s_axi_arid =>         (others => '0'),
--    s_axi_araddr =>       bmg_axi_araddr, 
--    s_axi_arlen =>        bmg_axi_arlen,
--    s_axi_arsize =>       bmg_axi_arsize, 
--    s_axi_arburst =>      bmg_axi_arburst,
--    s_axi_arvalid =>      bmg_axi_arvalid,
--    s_axi_arready =>      bmg_axi_arready,
--    s_axi_rid =>          bmg_axi_rid, 
--    s_axi_rdata =>        bmg_axi_rdata,
--    s_axi_rresp =>        bmg_axi_rresp,
--    s_axi_rlast =>        bmg_axi_rlast,
--    s_axi_rvalid =>       bmg_axi_rvalid, 
--    s_axi_rready =>       bmg_axi_rready
--  );




 SG_ABC : axi_bram_ctrl_3

   PORT MAP (
       -- AXI Clock and Reset
       s_axi_aclk         => axi_clk,
       s_axi_aresetn      => axi_aresetn,
       S_AXI_AWLOCK       => '0', --one_gnd,
   --    s_axi_awid     => four_gnd, --(others => '0'),
       s_axi_awaddr   => bmg_axi_awaddr (11 downto 0),
       s_axi_araddr   => bmg_axi_araddr (11 downto 0),

       s_axi_awlen    => bmg_axi_awlen,
       s_axi_awsize   => bmg_axi_awsize,
       s_axi_awburst  => bmg_axi_awburst,
       s_axi_awvalid  => bmg_axi_awvalid,
       s_axi_awready  => bmg_axi_awready,
       s_axi_wdata    => bmg_axi_wdata,
       s_axi_wstrb    => bmg_axi_wstrb,
       s_axi_wlast    => bmg_axi_wlast,
       s_axi_wvalid   => bmg_axi_wvalid,
       s_axi_wready   => bmg_axi_wready,
       S_AXI_AWCACHE  => "0011", --S_AXI_AWCACHE, 
       S_AXI_AWPROT   => "000",        --S_AXI_AWPROT,  

       s_axi_bresp    => bmg_axi_bresp,
       s_axi_bvalid   => bmg_axi_bvalid,
       s_axi_bready   => bmg_axi_bready,
       S_AXI_ARLOCK   => '0', --one_gnd,
  --     s_axi_arid     => four_gnd, --(others => '0'),
--       s_axi_araddr   => bmg_axi_araddr (11 downto 0),
       s_axi_arlen    => bmg_axi_arlen,
       s_axi_arsize   => bmg_axi_arsize,
       s_axi_arburst  => bmg_axi_arburst,
       s_axi_arvalid  => bmg_axi_arvalid,
       s_axi_arready  => bmg_axi_arready,
       S_AXI_ARCACHE  => "0011", --S_AXI_AWCACHE, 
       S_AXI_ARPROT   => "000",      --  S_AXI_AWPROT,  

      -- s_axi_rid      => open,
       s_axi_rdata    => bmg_axi_rdata,
       s_axi_rresp    => bmg_axi_rresp,
       s_axi_rlast    => bmg_axi_rlast,
       s_axi_rvalid   => bmg_axi_rvalid,
       s_axi_rready   => bmg_axi_rready,


      --I/O - Port A
    BRAM_Rst_A          =>        BRAM_Rst_A,
    BRAM_En_A           =>        BRAM_En_A,
    BRAM_WE_A           =>        BRAM_WE_A,
    BRAM_Addr_A         =>        BRAM_Addr_A,
    BRAM_RdData_A       =>        BRAM_RdData_A,
    BRAM_WrData_A       =>        BRAM_WrData_A,
    BRAM_Clk_A          =>        BRAM_Clk_A
);

xpm_memory_spram_inst : xpm_memory_spram
  generic map (

    -- Common module generics
    MEMORY_SIZE        => 16384,        --positive integer
    MEMORY_PRIMITIVE   => "auto",      --string; "auto", "distributed", "block" or "ultra" ;
    MEMORY_INIT_FILE   => "mem_data.mem",      --string; "none" or "<filename>.mem" 
    MEMORY_INIT_PARAM  => "",          --string;
    USE_MEM_INIT       => 1,           --integer; 0,1
    WAKEUP_TIME        => "disable_sleep",--string; "disable_sleep" or "use_sleep_pin" 
    MESSAGE_CONTROL    => 0,           --integer; 0,1
    ECC_MODE           => "no_ecc",    --string; "no_ecc", "encode_only", "decode_only" or "both_encode_and_decode" 
    AUTO_SLEEP_TIME    => 0,           --Do not Change


    -- Port A module generics
    WRITE_DATA_WIDTH_A => 32,          --positive integer
    READ_DATA_WIDTH_A  => 32,          --positive integer
    BYTE_WRITE_WIDTH_A => 8,          --integer; 8, 9, or WRITE_DATA_WIDTH_A value
    ADDR_WIDTH_A       => 9,           --positive integer
    READ_RESET_VALUE_A => "0",         --string
    READ_LATENCY_A     => 1,           --non-negative integer
    WRITE_MODE_A       => "read_first" --string; "write_first", "read_first", "no_change" 
  )
  port map (

    -- Common module ports
    sleep          =>  '0',

    -- Port A module ports
    clka           =>  BRAM_Clk_A,
    rsta           =>  BRAM_Rst_A,
    ena            =>  BRAM_En_A,
    regcea         =>  '1', --regcea,
    wea            =>  BRAM_WE_A(3 downto 0),
    addra          =>  BRAM_Addr_A (8 downto 0),
    dina           =>  BRAM_WrData_A(31 downto 0),
    injectsbiterra =>  '0',
    injectdbiterra =>  '0',
    douta          =>  BRAM_RdData_A(31 downto 0),
    sbiterra       =>  open,
    dbiterra       =>  open
  );



DUT : axi_emc_0
 port map (
    s_axi_aclk =>             axi_clk,
    s_axi_aresetn =>          axi_aresetn,
    rdclk =>                  axi_clk,
    s_axi_mem_awaddr =>       emc_axi_awaddr, 
    s_axi_mem_awlen =>        emc_axi_awlen, 
    s_axi_mem_awsize =>       emc_axi_awsize,
    s_axi_mem_awburst =>      emc_axi_awburst,
    s_axi_mem_awlock =>       '0', 
    s_axi_mem_awcache =>      emc_axi_awcache,
    s_axi_mem_awprot =>       emc_axi_awprot, 
    s_axi_mem_awvalid =>      emc_axi_awvalid,
    s_axi_mem_awready =>      emc_axi_awready,
    s_axi_mem_wdata =>        emc_axi_wdata, 
    s_axi_mem_wstrb =>        emc_axi_wstrb,
    s_axi_mem_wlast =>        emc_axi_wlast, 
    s_axi_mem_wvalid =>       emc_axi_wvalid, 
    s_axi_mem_wready =>       emc_axi_wready, 
    s_axi_mem_bresp =>        emc_axi_bresp, 
    s_axi_mem_bvalid =>       emc_axi_bvalid, 
    s_axi_mem_bready =>       emc_axi_bready, 
    s_axi_mem_araddr =>       emc_axi_araddr, 
    s_axi_mem_arlen =>        emc_axi_arlen, 
    s_axi_mem_arsize =>       emc_axi_arsize, 
    s_axi_mem_arburst =>      emc_axi_arburst,
    s_axi_mem_arlock =>       '0', 
    s_axi_mem_arcache =>      emc_axi_arcache,
    s_axi_mem_arprot =>       emc_axi_arprot, 
    s_axi_mem_arvalid =>      emc_axi_arvalid,
    s_axi_mem_arready =>      emc_axi_arready,
    s_axi_mem_rdata =>        emc_axi_rdata, 
    s_axi_mem_rresp =>        emc_axi_rresp, 
    s_axi_mem_rlast =>        emc_axi_rlast, 
    s_axi_mem_rvalid =>       emc_axi_rvalid, 
    s_axi_mem_rready =>       emc_axi_rready, 
    mem_dq_i =>               dq_i,
    mem_dq_o =>               dq_o,
    mem_dq_t =>               dq_t,
    mem_a =>                  a,
    mem_ce =>                 open,    
    mem_cen =>                cen,    
    mem_oen =>                oen,    
    mem_wen =>                wen,    
    mem_ben =>                ben,    
    mem_qwen =>               open,   
    mem_rpn =>                open,    
    mem_adv_ldn =>            open,
    mem_lbon =>               open,   
    mem_cken =>               cken,   
    mem_rnw =>                open,   
    mem_cre =>                open,
    mem_wait =>               mwait
);

end impl;
