# file: axi_emc_exdes.xdc
# 
# (c) Copyright 2008 - 2013 Xilinx, Inc. All rights reserved.
# 
# This file contains confidential and proprietary information
# of Xilinx, Inc. and is protected under U.S. and
# international copyright and other intellectual property
# laws.
# 
# DISCLAIMER
# This disclaimer is not a license and does not grant any
# rights to the materials distributed herewith. Except as
# otherwise provided in a valid license issued to you by
# Xilinx, and to the maximum extent permitted by applicable
# law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
# WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
# AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
# BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
# INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
# (2) Xilinx shall not be liable (whether in contract or tort,
# including negligence, or under any other theory of
# liability) for any loss or damage of any kind or nature
# related to, arising under or in connection with these
# materials, including for any direct, or any indirect,
# special, incidental, or consequential loss or damage
# (including loss of data, profits, goodwill, or any type of
# loss or damage suffered as a result of any action brought
# by a third party) even if such damage or loss was
# reasonably foreseeable or Xilinx had been advised of the
# possibility of the same.
# 
# CRITICAL APPLICATIONS
# Xilinx products are not designed or intended to be fail-
# safe, or for use in any application requiring fail-safe
# performance, such as life-support or safety devices or
# systems, Class III medical devices, nuclear facilities,
# applications related to the deployment of airbags, or any
# other applications that could lead to death, personal
# injury, or severe property or environmental damage
# (individually and collectively, "Critical
# Applications"). Customer assumes the sole risk and
# liability of any use of Xilinx products in Critical
# Applications, subject only to applicable laws and
# regulations governing limitations on product liability.
# 
# THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
# PART OF THIS FILE AT ALL TIMES.
# 
#----------------------------------------------------------------

set_property CFGBVS VCCO [current_design]
set_property CONFIG_VOLTAGE 3.3 [current_design]
set_property BITSTREAM.CONFIG.UNUSEDPIN PULLUP [current_design]

#############SPI Configurate Setting##################
set_property BITSTREAM.CONFIG.SPI_BUSWIDTH 4 [current_design]
set_property CONFIG_MODE SPIx4 [current_design]
set_property BITSTREAM.CONFIG.CONFIGRATE 50 [current_design]

############## clock and reset define##################
create_clock -period 20.000 -waveform {0.000 5.000} [get_ports clk50MHz]
set_property PACKAGE_PIN H11 [get_ports clk50MHz]
set_property IOSTANDARD LVCMOS33 [get_ports clk50MHz]
###set_property CLOCK_DEDICATED_ROUTE FALSE [get_nets {CLK50MHz_IBUF}]

#LEDs
#set_property -dict {PACKAGE_PIN C4 IOSTANDARD LVCMOS33} [get_ports led]

#UART
#set_property -dict {PACKAGE_PIN P4 IOSTANDARD LVCMOS33} [get_ports usb_uart_rxd]
#set_property -dict {PACKAGE_PIN P3 IOSTANDARD LVCMOS33} [get_ports usb_uart_txd]

#external reset pin
set_property -dict {PACKAGE_PIN M5 IOSTANDARD LVCMOS33} [get_ports reset]
#set_property -dict {PACKAGE_PIN C12 IOSTANDARD LVCMOS33} [get_ports reset_rtl_0]


# DATA I/O
set_property -dict {PACKAGE_PIN M4 IOSTANDARD LVCMOS33} [get_ports {dq[0]}]
set_property -dict {PACKAGE_PIN M3 IOSTANDARD LVCMOS33} [get_ports {dq[1]}] 
set_property -dict {PACKAGE_PIN M2 IOSTANDARD LVCMOS33} [get_ports {dq[2]}]
set_property -dict {PACKAGE_PIN M1 IOSTANDARD LVCMOS33} [get_ports {dq[3]}] 
set_property -dict {PACKAGE_PIN L1 IOSTANDARD LVCMOS33} [get_ports {dq[4]}]
set_property -dict {PACKAGE_PIN L3 IOSTANDARD LVCMOS33} [get_ports {dq[5]}] 
set_property -dict {PACKAGE_PIN L2 IOSTANDARD LVCMOS33} [get_ports {dq[6]}]
set_property -dict {PACKAGE_PIN K4 IOSTANDARD LVCMOS33} [get_ports {dq[7]}] 
set_property -dict {PACKAGE_PIN K3 IOSTANDARD LVCMOS33} [get_ports {dq[8]}]
set_property -dict {PACKAGE_PIN J4 IOSTANDARD LVCMOS33} [get_ports {dq[9]}] 
set_property -dict {PACKAGE_PIN J3 IOSTANDARD LVCMOS33} [get_ports {dq[10]}]
set_property -dict {PACKAGE_PIN J2 IOSTANDARD LVCMOS33} [get_ports {dq[11]}] 
set_property -dict {PACKAGE_PIN J1 IOSTANDARD LVCMOS33} [get_ports {dq[12]}]
set_property -dict {PACKAGE_PIN H3 IOSTANDARD LVCMOS33} [get_ports {dq[13]}] 
set_property -dict {PACKAGE_PIN H4 IOSTANDARD LVCMOS33} [get_ports {dq[14]}]
set_property -dict {PACKAGE_PIN H1 IOSTANDARD LVCMOS33} [get_ports {dq[15]}] 

#ADDRESS 
set_property -dict {PACKAGE_PIN H2 IOSTANDARD LVCMOS33} [get_ports {a[0]}] 
set_property -dict {PACKAGE_PIN F4 IOSTANDARD LVCMOS33} [get_ports {a[1]}] 
set_property -dict {PACKAGE_PIN G4 IOSTANDARD LVCMOS33} [get_ports {a[2]}] 
set_property -dict {PACKAGE_PIN F3 IOSTANDARD LVCMOS33} [get_ports {a[3]}] 
set_property -dict {PACKAGE_PIN F2 IOSTANDARD LVCMOS33} [get_ports {a[4]}] 
set_property -dict {PACKAGE_PIN F1 IOSTANDARD LVCMOS33} [get_ports {a[5]}] 
set_property -dict {PACKAGE_PIN G1 IOSTANDARD LVCMOS33} [get_ports {a[6]}] 
set_property -dict {PACKAGE_PIN C1 IOSTANDARD LVCMOS33} [get_ports {a[7]}] 
set_property -dict {PACKAGE_PIN D1 IOSTANDARD LVCMOS33} [get_ports {a[8]}] 
set_property -dict {PACKAGE_PIN D2 IOSTANDARD LVCMOS33} [get_ports {a[9]}] 
set_property -dict {PACKAGE_PIN E2 IOSTANDARD LVCMOS33} [get_ports {a[10]}] 
set_property -dict {PACKAGE_PIN B2 IOSTANDARD LVCMOS33} [get_ports {a[11]}] 
set_property -dict {PACKAGE_PIN B1 IOSTANDARD LVCMOS33} [get_ports {a[12]}]
set_property -dict {PACKAGE_PIN D4 IOSTANDARD LVCMOS33} [get_ports {a[13]}]
set_property -dict {PACKAGE_PIN E4 IOSTANDARD LVCMOS33} [get_ports {a[14]}] 
set_property -dict {PACKAGE_PIN B3 IOSTANDARD LVCMOS33} [get_ports {a[15]}]
set_property -dict {PACKAGE_PIN A2 IOSTANDARD LVCMOS33} [get_ports {a[16]}] 
set_property -dict {PACKAGE_PIN A4 IOSTANDARD LVCMOS33} [get_ports {a[17]}] 

set_property -dict {PACKAGE_PIN D14 IOSTANDARD LVCMOS33} [get_ports {a[18]}] 
set_property -dict {PACKAGE_PIN L13 IOSTANDARD LVCMOS33} [get_ports {a[19]}] 
set_property -dict {PACKAGE_PIN C14 IOSTANDARD LVCMOS33} [get_ports {a[20]}] 
set_property -dict {PACKAGE_PIN M13 IOSTANDARD LVCMOS33} [get_ports {a[21]}] 
set_property -dict {PACKAGE_PIN M14 IOSTANDARD LVCMOS33} [get_ports {a[22]}] 
set_property -dict {PACKAGE_PIN N14 IOSTANDARD LVCMOS33} [get_ports {a[23]}] 
set_property -dict {PACKAGE_PIN K12 IOSTANDARD LVCMOS33} [get_ports {a[24]}] 
set_property -dict {PACKAGE_PIN K11 IOSTANDARD LVCMOS33} [get_ports {a[25]}] 
set_property -dict {PACKAGE_PIN J11 IOSTANDARD LVCMOS33} [get_ports {a[26]}] 
set_property -dict {PACKAGE_PIN J12 IOSTANDARD LVCMOS33} [get_ports {a[27]}] 
set_property -dict {PACKAGE_PIN J13 IOSTANDARD LVCMOS33} [get_ports {a[28]}] 
set_property -dict {PACKAGE_PIN J14 IOSTANDARD LVCMOS33} [get_ports {a[29]}] 
set_property -dict {PACKAGE_PIN H13 IOSTANDARD LVCMOS33} [get_ports {a[30]}] 
set_property -dict {PACKAGE_PIN H14 IOSTANDARD LVCMOS33} [get_ports {a[31]}] 


# SRAM IC Control Signals
set_property -dict {PACKAGE_PIN A3 IOSTANDARD LVCMOS33} [get_ports {cen[0]}] 

set_property -dict {PACKAGE_PIN C3 IOSTANDARD LVCMOS33} [get_ports {ben[0]}] 
set_property -dict {PACKAGE_PIN D3 IOSTANDARD LVCMOS33} [get_ports {ben[1]}] 

#set_property -dict {PACKAGE_PIN A5 IOSTANDARD LVCMOS33} [get_ports {ce[0]}]
#set_property -dict {PACKAGE_PIN B5 IOSTANDARD LVCMOS33} [get_ports {ce_n[0]}]
set_property -dict {PACKAGE_PIN H12 IOSTANDARD LVCMOS33} [get_ports clk]
set_property -dict {PACKAGE_PIN M10 IOSTANDARD LVCMOS33} [get_ports cken]
set_property -dict {PACKAGE_PIN P11 IOSTANDARD LVCMOS33} [get_ports wen]
set_property -dict {PACKAGE_PIN P10 IOSTANDARD LVCMOS33} [get_ports {oen[0]}] 
set_property -dict {PACKAGE_PIN N11 IOSTANDARD LVCMOS33} [get_ports {atg_status[0]}] 
set_property -dict {PACKAGE_PIN N10 IOSTANDARD LVCMOS33} [get_ports {atg_status[1]}]
#set_property -dict {PACKAGE_PIN M12 IOSTANDARD LVCMOS33} [get_ports rnw]
#set_property -dict {PACKAGE_PIN M11 IOSTANDARD LVCMOS33} [get_ports rpn]
set_property -dict {PACKAGE_PIN P13 IOSTANDARD LVCMOS33} [get_ports {mwait[0]}] 
set_property -dict {PACKAGE_PIN P12 IOSTANDARD LVCMOS33} [get_ports atg_done ]


# SRAM IC Control Signals
#set_property -dict {PACKAGE_PIN A3 IOSTANDARD LVCMOS33} [get_ports emc_rtl_0_adv_ldn]
#set_property -dict {PACKAGE_PIN C3 IOSTANDARD LVCMOS33} [get_ports {emc_rtl_0_ben[0]}] 
#set_property -dict {PACKAGE_PIN D3 IOSTANDARD LVCMOS33} [get_ports {emc_rtl_0_ben[1]}] 
#set_property -dict {PACKAGE_PIN A5 IOSTANDARD LVCMOS33} [get_ports {emc_rtl_0_ce[0]}]
#set_property -dict {PACKAGE_PIN B5 IOSTANDARD LVCMOS33} [get_ports {emc_rtl_0_ce_n[0]}]
#set_property -dict {PACKAGE_PIN H12 IOSTANDARD LVCMOS33} [get_ports emc_rtl_0_clken]
#set_property -dict {PACKAGE_PIN M10 IOSTANDARD LVCMOS33} [get_ports emc_rtl_0_cre]
#set_property -dict {PACKAGE_PIN P11 IOSTANDARD LVCMOS33} [get_ports emc_rtl_0_lbon]
#set_property -dict {PACKAGE_PIN P10 IOSTANDARD LVCMOS33} [get_ports {emc_rtl_0_oen[0]}]
#set_property -dict {PACKAGE_PIN N11 IOSTANDARD LVCMOS33} [get_ports {emc_rtl_0_qwen[0]}] 
#set_property -dict {PACKAGE_PIN N10 IOSTANDARD LVCMOS33} [get_ports {emc_rtl_0_qwen[1]}]
#set_property -dict {PACKAGE_PIN M12 IOSTANDARD LVCMOS33} [get_ports emc_rtl_0_rnw]
#set_property -dict {PACKAGE_PIN M11 IOSTANDARD LVCMOS33} [get_ports emc_rtl_0_rpn]
#set_property -dict {PACKAGE_PIN P13 IOSTANDARD LVCMOS33} [get_ports {emc_rtl_0_wait[0]}] 
#set_property -dict {PACKAGE_PIN P12 IOSTANDARD LVCMOS33} [get_ports emc_rtl_0_wen]


###############-----------------------------------------------------------------------------------------------
##create_clock -name clk_p -period 5.0 [get_ports clk_p]

#Following constrains are targetted for KC705 board

#set_property BITSTREAM.GENERAL.UNCONSTRAINEDPINS Allow [current_design]

#set_property PACKAGE_PIN AD12 [get_ports clk_p]

#set_property PACKAGE_PIN AD11 [get_ports clk_n]

#set_property PACKAGE_PIN AB7 [get_ports reset]

#set_property PACKAGE_PIN P24 [get_ports dq[0]]

#set_property PACKAGE_PIN R25 [get_ports dq[1]]

#set_property PACKAGE_PIN R20 [get_ports dq[2]]

#set_property PACKAGE_PIN R21 [get_ports dq[3]]

#set_property PACKAGE_PIN T20 [get_ports dq[4]]

#set_property PACKAGE_PIN T21 [get_ports dq[5]]

#set_property PACKAGE_PIN T22 [get_ports dq[6]]

#set_property PACKAGE_PIN T23 [get_ports dq[7]]

#set_property PACKAGE_PIN U20 [get_ports dq[8]]

#set_property PACKAGE_PIN P29 [get_ports dq[9]]

#set_property PACKAGE_PIN R29 [get_ports dq[10]]

#set_property PACKAGE_PIN P27 [get_ports dq[11]]

#set_property PACKAGE_PIN P28 [get_ports dq[12]]

#set_property PACKAGE_PIN T30 [get_ports dq[13]]

#set_property PACKAGE_PIN P26 [get_ports dq[14]]

#set_property PACKAGE_PIN R26 [get_ports dq[15]]

#set_property PACKAGE_PIN W22 [get_ports a[0]]

#set_property PACKAGE_PIN W21 [get_ports a[1]]

#set_property PACKAGE_PIN V24 [get_ports a[2]]

#set_property PACKAGE_PIN U24 [get_ports a[3]]

#set_property PACKAGE_PIN V22 [get_ports a[4]]

#set_property PACKAGE_PIN V21 [get_ports a[5]]

#set_property PACKAGE_PIN U23 [get_ports a[6]]

#set_property PACKAGE_PIN W24 [get_ports a[7]]

#set_property PACKAGE_PIN W23 [get_ports a[8]]

#set_property PACKAGE_PIN V20 [get_ports a[9]]

#set_property PACKAGE_PIN V19 [get_ports a[10]]

#set_property PACKAGE_PIN W26 [get_ports a[11]]

#set_property PACKAGE_PIN V25 [get_ports a[12]]

#set_property PACKAGE_PIN V30 [get_ports a[13]]

#set_property PACKAGE_PIN V29 [get_ports a[14]]

#set_property PACKAGE_PIN V27 [get_ports a[15]]

#set_property PACKAGE_PIN P22 [get_ports a[16]]

#set_property PACKAGE_PIN P21 [get_ports a[17]]

#set_property PACKAGE_PIN N24 [get_ports a[18]]

#set_property PACKAGE_PIN N22 [get_ports a[19]]

#set_property PACKAGE_PIN N21 [get_ports a[20]]

#set_property PACKAGE_PIN N20 [get_ports a[21]]

#set_property PACKAGE_PIN N19 [get_ports a[22]]

#set_property PACKAGE_PIN N26 [get_ports a[23]]

#set_property PACKAGE_PIN M23 [get_ports a[24]]

#set_property PACKAGE_PIN M22 [get_ports a[25]]

#set_property PACKAGE_PIN B10 [get_ports clk]

#set_property PACKAGE_PIN U29 [get_ports mwait]

#set_property PACKAGE_PIN M25 [get_ports wen]

#set_property PACKAGE_PIN M24 [get_ports oen]

#set_property PACKAGE_PIN U19 [get_ports cen]

#set_property PACKAGE_PIN AB8 [get_ports atg_done]

#set_property PACKAGE_PIN AC9 [get_ports atg_status[0]]

#set_property PACKAGE_PIN AB9 [get_ports atg_status[1]]

#set_property IOSTANDARD DIFF_SSTL15 [get_ports clk_p]

#set_property IOSTANDARD DIFF_SSTL15 [get_ports clk_n]

#set_property IOSTANDARD LVCMOS18 [get_ports a[0]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[1]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[2]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[3]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[4]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[5]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[6]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[7]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[8]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[9]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[10]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[11]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[12]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[13]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[14]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[15]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[16]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[17]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[18]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[19]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[20]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[21]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[22]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[23]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[24]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[25]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[26]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[27]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[28]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[29]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[30]]

#set_property IOSTANDARD LVCMOS18 [get_ports a[31]]

#set_property IOSTANDARD LVCMOS18 [get_ports dq[0]]

#set_property IOSTANDARD LVCMOS18 [get_ports dq[1]]

#set_property IOSTANDARD LVCMOS18 [get_ports dq[2]]

#set_property IOSTANDARD LVCMOS18 [get_ports dq[3]]

#set_property IOSTANDARD LVCMOS18 [get_ports dq[4]]

#set_property IOSTANDARD LVCMOS18 [get_ports dq[5]]

#set_property IOSTANDARD LVCMOS18 [get_ports dq[6]]

#set_property IOSTANDARD LVCMOS18 [get_ports dq[7]]

#set_property IOSTANDARD LVCMOS18 [get_ports dq[8]]

#set_property IOSTANDARD LVCMOS18 [get_ports dq[9]]

#set_property IOSTANDARD LVCMOS18 [get_ports dq[10]]

#set_property IOSTANDARD LVCMOS18 [get_ports dq[11]]

#set_property IOSTANDARD LVCMOS18 [get_ports dq[12]]

#set_property IOSTANDARD LVCMOS18 [get_ports dq[13]]

#set_property IOSTANDARD LVCMOS18 [get_ports dq[14]]

#set_property IOSTANDARD LVCMOS18 [get_ports dq[15]]

#set_property IOSTANDARD LVCMOS18 [get_ports reset]

#set_property IOSTANDARD LVCMOS18 [get_ports cen]

#set_property IOSTANDARD LVCMOS18 [get_ports oen]

#set_property IOSTANDARD LVCMOS18 [get_ports wen]

#set_property IOSTANDARD LVCMOS18 [get_ports ben[0]]

#set_property IOSTANDARD LVCMOS18 [get_ports ben[1]]

#set_property IOSTANDARD LVCMOS18 [get_ports cken]

#set_property IOSTANDARD LVCMOS18 [get_ports clk]

#set_property IOSTANDARD LVCMOS18 [get_ports mwait]

#set_property IOSTANDARD LVCMOS18 [get_ports atg_done]

#set_property IOSTANDARD LVCMOS18 [get_ports atg_status[0]]

#set_property IOSTANDARD LVCMOS18 [get_ports atg_status[1]]
